#include "waveclass.cc"

int main(void)
{  
   char *cData;
   WaveData *pWave;
   WaveData *pSave;
   string filename;
   int i; 				// what else?! 
   unsigned int j;
   int keepLooping = 1;
   char opName;
   long blockSize;	// global control of space allocated to multiple files
                  	// e.g. for mixdown
  
   while (keepLooping)
   {
      cout << "(L)oad (S)ave (D)isplay (N)ext (Q)uit\n";
      cin >> opName;
   
      switch(opName)
      {
      	case 'l':
         case 'L':
            pWave = new WaveData;	// writes a new (valid) header!
            cout << "filename? \n";
            cin >> filename;
        
          	if (!pWave->LoadWav(filename))
            {            
            	cout << "error loading " << filename << "\n";                     
            }
            else
            {
               pWave->display();
               
               // how to get at byte data 
               cout << "data? (y/n)\n";
               cin >> opName;
                        
               if ((opName == 'y') || (opName == 'Y'))
               {
               	cData = pWave->data();
                  long dataLength = pWave->dataLength();
               
                  for (i = 0; i < dataLength; i++)
                  {
                  	j = (unsigned char) cData[i];
                     cout << j << " ";
                  }
            
               	cout << "\n";
               }              
            }     
           
         	break;
   
      	case 's':
         case 'S':
            // n.b. this only saves a complete file from memory
            cout << "filename? \n";
            cin >> filename;

         	if (!pWave->SaveWav(filename))
               cout << "error loading " << filename << "\n";
            else
               pWave->display();

      	case 'd':
         case 'D':
            pWave->display();
            break;
                           
         case 'n':
         case 'N':
            pWave = pWave->next();
            
            if (pWave == NULL)
               pWave = pWave->first();
               
            pWave->display();               
            break;
      
         case 'q':
         case 'Q':
            keepLooping = 0;
            break;
         
         default:;
      }
   }

   for (pWave = pWave->first(); pWave; pWave = pWave->next())
      delete pWave;	// delete pWave, pSave, other instances, ...
      
   return 0;
}

